# Interface CLNFileReadableType

All Superinterfaces:
  `AutoCloseable`

All Known Implementing Classes:
  `CLN2FileReadable`

public interface CLNFileReadableType extends AutoCloseable
A readable file.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  `default Optional<CLNSectionReadableEndType>`
  `openEnd()`
  `default Optional<CLNSectionReadableImage2DType>`
  `openImage2D()`
  `default Optional<CLNSectionReadableImageArrayType>`
  `openImageArray()`
  `default Optional<CLNSectionReadableImageCubeType>`
  `openImageCube()`
  `default Optional<CLNSectionReadableImageInfoType>`
  `openImageInfo()`
  `default Optional<CLNSectionReadableMetadataType>`
  `openMetadata()`
  `CLNSectionReadableType`
  `openSection(com.io7m.entomos.core.EoFileSection description)`
  Open a section for reading.
  `NavigableSet<com.io7m.entomos.core.EoFileSection>`
  `sections()`
  `long`
  `trailingOctets()`
  Obtain the number of trailing octets in the file.
  `CLNVersion`
  `version()`

- ## Method Details

  - ### close

    void close() throws CLNException
    Specified by:
      `close` in interface `AutoCloseable`
    Throws:
      `CLNException`

  - ### sections

    NavigableSet<com.io7m.entomos.core.EoFileSection> sections()
    Returns:
      The list of sections in the file

  - ### version

    CLNVersion version()
    Returns:
      The file version

  - ### openSection

    CLNSectionReadableType openSection(com.io7m.entomos.core.EoFileSection description)
    Open a section for reading.
    Parameters:
      `description` - The section description
    Returns:
      A readable section

  - ### openImageInfo

    default Optional<CLNSectionReadableImageInfoType> openImageInfo()
    Returns:
      The first available image info section, if one exists

  - ### openImage2D

    default Optional<CLNSectionReadableImage2DType> openImage2D()
    Returns:
      The first available image 2D section, if one exists

  - ### openImageCube

    default Optional<CLNSectionReadableImageCubeType> openImageCube()
    Returns:
      The first available image cube section, if one exists

  - ### openImageArray

    default Optional<CLNSectionReadableImageArrayType> openImageArray()
    Returns:
      The first available image array section, if one exists

  - ### openMetadata

    default Optional<CLNSectionReadableMetadataType> openMetadata()
    Returns:
      The first available metadata section, if one exists

  - ### openEnd

    default Optional<CLNSectionReadableEndType> openEnd()
    Returns:
      The first available end section, if one exists

  - ### trailingOctets

    long trailingOctets()
    Obtain the number of trailing octets in the file. This value should always be zero for valid files.
    Returns:
      The number of trailing octets